--- /home/monnier/work/xemacs/src/regex.c	Thu Dec 14 17:15:15 2000
+++ src/regex.c.1.138	Thu Apr 26 09:32:57 2001
@@ -3876,43 +3879,40 @@
     }
 }
 
-/* Searching routines.  */
+/* Searching routines.	*/
 
 /* Like re_search_2, below, but only one string is specified, and
    doesn't let you say where to stop matching. */
 
 int
-re_search (struct re_pattern_buffer *bufp, const char *string, int size,
-	   int startpos, int range, struct re_registers *regs)
+re_search (bufp, string, size, startpos, range, regs)
+     struct re_pattern_buffer *bufp;
+     const char *string;
+     int size, startpos, range;
+     struct re_registers *regs;
 {
   return re_search_2 (bufp, NULL, 0, string, size, startpos, range,
 		      regs, size);
 }
 
-#ifndef emacs
-/* Snarfed from src/lisp.h, needed for compiling [ce]tags. */
-# define bytecount_to_charcount(ptr, len) (len)
-# define charcount_to_bytecount(ptr, len) (len)
-typedef int Charcount;
-#endif
+/* End address of virtual concatenation of string.  */
+#define STOP_ADDR_VSTRING(P)				\
+  (((P) >= size1 ? string2 + size2 : string1 + size1))
+
+/* Address of POS in the concatenation of virtual string. */
+#define POS_ADDR_VSTRING(POS)					\
+  (((POS) >= size1 ? string2 - size1 : string1) + (POS))
 
 /* Using the compiled pattern in BUFP->buffer, first tries to match the
    virtual concatenation of STRING1 and STRING2, starting first at index
    STARTPOS, then at STARTPOS + 1, and so on.
 
-   With MULE, STARTPOS is a byte position, not a char position.  And the
-   search will increment STARTPOS by the width of the current leading
-   character.
-
    STRING1 and STRING2 have length SIZE1 and SIZE2, respectively.
 
    RANGE is how far to scan while trying to match.  RANGE = 0 means try
    only at STARTPOS; in general, the last start tried is STARTPOS +
    RANGE.
 
-   With MULE, RANGE is a byte position, not a char position.  The last
-   start tried is the character starting <= STARTPOS + RANGE.
-
    In REGS, return the indices of the virtual concatenation of STRING1
    and STRING2 that matched the entire BUFP->buffer and its contained
    subexpressions.
@@ -3925,183 +3925,171 @@
    stack overflow).  */
 
 int
-re_search_2 (struct re_pattern_buffer *bufp, const char *str1,
-	     int size1, const char *str2, int size2, int startpos,
-	     int range, struct re_registers *regs, int stop)
+re_search_2 (bufp, string1, size1, string2, size2, startpos, range, regs, stop)
+     struct re_pattern_buffer *bufp;
+     const char *string1, *string2;
+     int size1, size2;
+     int startpos;
+     int range;
+     struct re_registers *regs;
+     int stop;
 {
   int val;
-  re_char *string1 = (re_char *) str1;
-  re_char *string2 = (re_char *) str2;
-  REGISTER char *fastmap = bufp->fastmap;
-  REGISTER RE_TRANSLATE_TYPE translate = bufp->translate;
+  register char *fastmap = bufp->fastmap;
+  register RE_TRANSLATE_TYPE translate = bufp->translate;
   int total_size = size1 + size2;
   int endpos = startpos + range;
-#ifdef REGEX_BEGLINE_CHECK
-  int anchored_at_begline = 0;
-#endif
-  re_char *d;
-  Charcount d_size;
+  int anchored_start = 0;
+
+  /* Nonzero if we have to concern multibyte character.	 */
+  int multibyte = bufp->multibyte;
 
   /* Check for out-of-range STARTPOS.  */
   if (startpos < 0 || startpos > total_size)
     return -1;
 
   /* Fix up RANGE if it might eventually take us outside
-     the virtual concatenation of STRING1 and STRING2.  */
+     the virtual concatenation of STRING1 and STRING2.
+     Make sure we won't move STARTPOS below 0 or above TOTAL_SIZE.  */
   if (endpos < 0)
     range = 0 - startpos;
   else if (endpos > total_size)
     range = total_size - startpos;
 
   /* If the search isn't to be a backwards one, don't waste time in a
-     search for a pattern that must be anchored.  */
+     search for a pattern anchored at beginning of buffer.  */
   if (bufp->used > 0 && (re_opcode_t) bufp->buffer[0] == begbuf && range > 0)
     {
       if (startpos > 0)
 	return -1;
       else
-	{
-	  d = ((const unsigned char *)
-	       (startpos >= size1 ? string2 - size1 : string1) + startpos);
-	    range = charcount_to_bytecount (d, 1);
-	}
+	range = 0;
+    }
+
+#ifdef emacs
+  /* In a forward search for something that starts with \=.
+     don't keep searching past point.  */
+  if (bufp->used > 0 && (re_opcode_t) bufp->buffer[0] == at_dot && range > 0)
+    {
+      range = PT_BYTE - BEGV_BYTE - startpos;
+      if (range < 0)
+	return -1;
     }
+#endif /* emacs */
 
   /* Update the fastmap now if not correct already.  */
   if (fastmap && !bufp->fastmap_accurate)
     if (re_compile_fastmap (bufp) == -2)
       return -2;
 
-#ifdef REGEX_BEGLINE_CHECK
+  /* See whether the pattern is anchored.  */
+  if (bufp->buffer[0] == begline)
+    anchored_start = 1;
+
+#ifdef emacs
+  gl_state.object = re_match_object;
   {
-    int i = 0;
+    int adjpos = NILP (re_match_object) || BUFFERP (re_match_object);
+    int charpos = SYNTAX_TABLE_BYTE_TO_CHAR (startpos + adjpos);
 
-    while (i < bufp->used)
-      {
-	if (bufp->buffer[i] == start_memory ||
-	    bufp->buffer[i] == stop_memory)
-	  i += 2;
-	else
-	  break;
-      }
-    anchored_at_begline = i < bufp->used && bufp->buffer[i] == begline;
+    SETUP_SYNTAX_TABLE_FOR_OBJECT (re_match_object, charpos, 1);
   }
 #endif
 
   /* Loop through the string, looking for a place to start matching.  */
   for (;;)
     {
-#ifdef REGEX_BEGLINE_CHECK
-      /* If the regex is anchored at the beginning of a line (i.e. with a ^),
-	 then we can speed things up by skipping to the next beginning-of-
-	 line. */
-      if (anchored_at_begline && startpos > 0 && startpos != size1 &&
-	  range > 0)
+      /* If the pattern is anchored,
+	 skip quickly past places we cannot match.
+	 We don't bother to treat startpos == 0 specially
+	 because that case doesn't repeat.  */
+      if (anchored_start && startpos > 0)
 	{
-	  /* whose stupid idea was it anyway to make this
-	     function take two strings to match?? */
-	  int lim = 0;
-	  int irange = range;
-
-	  if (startpos < size1 && startpos + range >= size1)
-	    lim = range - (size1 - startpos);
-
-	  d = ((const unsigned char *)
-	       (startpos >= size1 ? string2 - size1 : string1) + startpos);
-	  DEC_CHARPTR(d);	/* Ok, since startpos != size1. */
-	  d_size = charcount_to_bytecount (d, 1);
-
-	  if (TRANSLATE_P (translate))
-	    while (range > lim && *d != '\n')
-	      {
-		d += d_size;	/* Speedier INC_CHARPTR(d) */
-		d_size = charcount_to_bytecount (d, 1);
-		range -= d_size;
-	      }
-	  else
-	    while (range > lim && *d != '\n')
-	      {
-		d += d_size;	/* Speedier INC_CHARPTR(d) */
-		d_size = charcount_to_bytecount (d, 1);
-		range -= d_size;
-	      }
-
-	  startpos += irange - range;
+	  if (! (bufp->newline_anchor
+		 && ((startpos <= size1 ? string1[startpos - 1]
+		      : string2[startpos - size1 - 1])
+		     == '\n')))
+	    goto advance;
 	}
-#endif /* REGEX_BEGLINE_CHECK */
 
       /* If a fastmap is supplied, skip quickly over characters that
-         cannot be the start of a match.  If the pattern can match the
-         null string, however, we don't need to skip characters; we want
-         the first null string.  */
+	 cannot be the start of a match.  If the pattern can match the
+	 null string, however, we don't need to skip characters; we want
+	 the first null string.	 */
       if (fastmap && startpos < total_size && !bufp->can_be_null)
 	{
-	  if (range > 0)	/* Searching forwards.  */
+	  register const char *d;
+	  register unsigned int buf_ch;
+
+	  d = POS_ADDR_VSTRING (startpos);
+
+	  if (range > 0)	/* Searching forwards.	*/
 	    {
-	      int lim = 0;
+	      register int lim = 0;
 	      int irange = range;
 
-              if (startpos < size1 && startpos + range >= size1)
-                lim = range - (size1 - startpos);
+	      if (startpos < size1 && startpos + range >= size1)
+		lim = range - (size1 - startpos);
 
-	      d = ((const unsigned char *)
-		   (startpos >= size1 ? string2 - size1 : string1) + startpos);
+	      /* Written out as an if-else to avoid testing `translate'
+		 inside the loop.  */
+	      if (RE_TRANSLATE_P (translate))
+		{
+		  if (multibyte)
+		    while (range > lim)
+		      {
+			int buf_charlen;
 
-              /* Written out as an if-else to avoid testing `translate'
-                 inside the loop.  */
-	      if (TRANSLATE_P (translate))
-                while (range > lim)
-		  {
-#ifdef MULE
-		    Emchar buf_ch;
+			buf_ch = STRING_CHAR_AND_LENGTH (d, range - lim,
+							 buf_charlen);
 
-		    buf_ch = charptr_emchar (d);
-		    buf_ch = RE_TRANSLATE (buf_ch);
-		    if (buf_ch >= 0200 || fastmap[(unsigned char) buf_ch])
-		      break;
-#else
-		    if (fastmap[(unsigned char)RE_TRANSLATE (*d)])
-		      break;
-#endif /* MULE */
-		    d_size = charcount_to_bytecount (d, 1);
-		    range -= d_size;
-		    d += d_size; /* Speedier INC_CHARPTR(d) */
-		  }
+			buf_ch = RE_TRANSLATE (translate, buf_ch);
+			if (buf_ch >= 0400
+			    || fastmap[buf_ch])
+			  break;
+
+			range -= buf_charlen;
+			d += buf_charlen;
+		      }
+		  else
+		    while (range > lim
+			   && !fastmap[(unsigned char)
+				       RE_TRANSLATE (translate, (unsigned char) *d)])
+		      {
+			d++;
+			range--;
+		      }
+		}
 	      else
-                while (range > lim && !fastmap[*d])
+		while (range > lim && !fastmap[(unsigned char) *d])
 		  {
-		    d_size = charcount_to_bytecount (d, 1);
-		    range -= d_size;
-		    d += d_size; /* Speedier INC_CHARPTR(d) */
+		    d++;
+		    range--;
 		  }
 
 	      startpos += irange - range;
 	    }
-	  else				/* Searching backwards.  */
+	  else				/* Searching backwards.	 */
 	    {
-	      Emchar c = (size1 == 0 || startpos >= size1
-			  ? charptr_emchar (string2 + startpos - size1)
-			  : charptr_emchar (string1 + startpos));
-	      c = TRANSLATE (c);
-#ifdef MULE
-	      if (!(c >= 0200 || fastmap[(unsigned char) c]))
-		goto advance;
-#else
-	      if (!fastmap[(unsigned char) c])
+	      int room = (size1 == 0 || startpos >= size1
+			  ? size2 + size1 - startpos
+			  : size1 - startpos);
+
+	      buf_ch = STRING_CHAR (d, room);
+	      if (RE_TRANSLATE_P (translate))
+		buf_ch = RE_TRANSLATE (translate, buf_ch);
+
+	      if (! (buf_ch >= 0400
+		     || fastmap[buf_ch]))
 		goto advance;
-#endif
 	    }
 	}
 
       /* If can't match the null string, and that's all we have left, fail.  */
       if (range >= 0 && startpos == total_size && fastmap
-          && !bufp->can_be_null)
+	  && !bufp->can_be_null)
 	return -1;
 
-#ifdef emacs /* XEmacs added, w/removal of immediate_quit */
-      if (!no_quit_in_re_search)
-	QUIT;
-#endif
       val = re_match_2_internal (bufp, string1, size1, string2, size2,
 				 startpos, regs, stop);
 #ifndef REGEX_MALLOC
@@ -4121,22 +4109,56 @@
 	break;
       else if (range > 0)
 	{
-	  d = ((const unsigned char *)
-	       (startpos >= size1 ? string2 - size1 : string1) + startpos);
-	  d_size = charcount_to_bytecount (d, 1);
-	  range -= d_size;
-	  startpos += d_size;
+	  /* Update STARTPOS to the next character boundary.  */
+	  if (multibyte)
+	    {
+	      const unsigned char *p
+		= (const unsigned char *) POS_ADDR_VSTRING (startpos);
+	      const unsigned char *pend
+		= (const unsigned char *) STOP_ADDR_VSTRING (startpos);
+	      int len = MULTIBYTE_FORM_LENGTH (p, pend - p);
+
+	      range -= len;
+	      if (range < 0)
+		break;
+	      startpos += len;
+	    }
+	  else
+	    {
+	      range--;
+	      startpos++;
+	    }
 	}
       else
 	{
-	  /* Note startpos > size1 not >=.  If we are on the
-	     string1/string2 boundary, we want to backup into string1. */
-	  d = ((const unsigned char *)
-	       (startpos > size1 ? string2 - size1 : string1) + startpos);
-	  DEC_CHARPTR(d);
-	  d_size = charcount_to_bytecount (d, 1);
-	  range += d_size;
-	  startpos -= d_size;
+	  range++;
+	  startpos--;
+
+	  /* Update STARTPOS to the previous character boundary.  */
+	  if (multibyte)
+	    {
+	      const unsigned char *p
+		= (const unsigned char *) POS_ADDR_VSTRING (startpos);
+	      int len = 0;
+
+	      /* Find the head of multibyte form.  */
+	      while (!CHAR_HEAD_P (*p))
+		p--, len++;
+
+	      /* Adjust it. */
+#if 0				/* XXX */
+	      if (MULTIBYTE_FORM_LENGTH (p, len + 1) != (len + 1))
+		;
+	      else
+#endif
+		{
+		  range += len;
+		  if (range > 0)
+		    break;
+
+		  startpos -= len;
+		}
+	    }
 	}
     }
   return -1;
@@ -4144,6 +4166,11 @@
 
 /* Declarations and macros for re_match_2.  */
 
+static int bcmp_translate ();
+static boolean alt_match_null_string_p (),
+	       common_op_match_null_string_p (),
+	       group_match_null_string_p ();
+
 /* This converts PTR, a pointer into one of the search strings `string1'
    and `string2' into an offset from the beginning of that string.  */
 #define POINTER_TO_OFFSET(ptr)			\
@@ -4158,37 +4185,53 @@
 /* Call before fetching a character with *d.  This switches over to
    string2 if necessary.  */
 #define PREFETCH()							\
-  while (d == dend)						    	\
+  while (d == dend)							\
     {									\
       /* End of string2 => fail.  */					\
-      if (dend == end_match_2) 						\
-        goto fail;							\
-      /* End of string1 => advance to string2.  */ 			\
-      d = string2;						        \
+      if (dend == end_match_2)						\
+	goto fail;							\
+      /* End of string1 => advance to string2.	*/			\
+      d = string2;							\
       dend = end_match_2;						\
     }
 
 
 /* Test if at very beginning or at very end of the virtual concatenation
-   of `string1' and `string2'.  If only one string, it's `string2'.  */
+   of `string1' and `string2'.	If only one string, it's `string2'.  */
 #define AT_STRINGS_BEG(d) ((d) == (size1 ? string1 : string2) || !size2)
 #define AT_STRINGS_END(d) ((d) == end2)
 
-/* XEmacs change:
-   If the given position straddles the string gap, return the equivalent
-   position that is before or after the gap, respectively; otherwise,
-   return the same position. */
-#define POS_BEFORE_GAP_UNSAFE(d) ((d) == string2 ? end1 : (d))
-#define POS_AFTER_GAP_UNSAFE(d) ((d) == end1 ? string2 : (d))
-
-/* Test if CH is a word-constituent character. (XEmacs change) */
-#define WORDCHAR_P_UNSAFE(ch)						   \
-  (SYNTAX_UNSAFE (XCHAR_TABLE (regex_emacs_buffer->mirror_syntax_table),   \
-                               ch) == Sword)
+
+/* Test if D points to a character which is word-constituent.  We have
+   two special cases to check for: if past the end of string1, look at
+   the first character in string2; and if before the beginning of
+   string2, look at the last character in string1.  */
+#define WORDCHAR_P(d)							\
+  (SYNTAX ((d) == end1 ? *string2					\
+	   : (d) == string2 - 1 ? *(end1 - 1) : *(d))			\
+   == Sword)
+
+/* Disabled due to a compiler bug -- see comment at case wordbound */
+
+/* The comment at case wordbound is following one, but we don't use
+   AT_WORD_BOUNDARY anymore to support multibyte form.
+
+   The DEC Alpha C compiler 3.x generates incorrect code for the
+   test	 WORDCHAR_P (d - 1) != WORDCHAR_P (d)  in the expansion of
+   AT_WORD_BOUNDARY, so this code is disabled.	Expanding the
+   macro and introducing temporary variables works around the bug.  */
+
+#if 0
+/* Test if the character before D and the one at D differ with respect
+   to being word-constituent.  */
+#define AT_WORD_BOUNDARY(d)						\
+  (AT_STRINGS_BEG (d) || AT_STRINGS_END (d)				\
+   || WORDCHAR_P (d - 1) != WORDCHAR_P (d))
+#endif
 
 /* Free everything we malloc.  */
 #ifdef MATCH_MAY_ALLOCATE
-#define FREE_VAR(var) if (var) REGEX_FREE (var); var = NULL
+#define FREE_VAR(var) if (var) { REGEX_FREE (var); var = NULL; } else
 #define FREE_VARIABLES()						\
   do {									\
     REGEX_FREE_STACK (fail_stack.stack);				\
@@ -4202,95 +4245,122 @@
     FREE_VAR (reg_dummy);						\
     FREE_VAR (reg_info_dummy);						\
   } while (0)
-#else /* not MATCH_MAY_ALLOCATE */
+#else
 #define FREE_VARIABLES() ((void)0) /* Do nothing!  But inhibit gcc warning.  */
-#endif /* MATCH_MAY_ALLOCATE */
+#endif /* not MATCH_MAY_ALLOCATE */
 
-/* These values must meet several constraints.  They must not be valid
+/* These values must meet several constraints.	They must not be valid
    register values; since we have a limit of 255 registers (because
    we use only one byte in the pattern for the register number), we can
-   use numbers larger than 255.  They must differ by 1, because of
+   use numbers larger than 255.	 They must differ by 1, because of
    NUM_FAILURE_ITEMS above.  And the value for the lowest register must
    be larger than the value for the highest register, so we do not try
-   to actually save any registers when none are active.  */
+   to actually save any registers when none are active.	 */
 #define NO_HIGHEST_ACTIVE_REG (1 << BYTEWIDTH)
 #define NO_LOWEST_ACTIVE_REG (NO_HIGHEST_ACTIVE_REG + 1)
 
 /* Matching routines.  */
 
-#ifndef emacs   /* Emacs never uses this.  */
+#ifndef emacs	/* Emacs never uses this.  */
 /* re_match is like re_match_2 except it takes only a single string.  */
 
 int
-re_match (struct re_pattern_buffer *bufp, const char *string, int size,
-	  int pos, struct re_registers *regs)
+re_match (bufp, string, size, pos, regs)
+     struct re_pattern_buffer *bufp;
+     const char *string;
+     int size, pos;
+     struct re_registers *regs;
 {
-  int result = re_match_2_internal (bufp, NULL, 0, (re_char *) string, size,
+  int result = re_match_2_internal (bufp, NULL, 0, string, size,
 				    pos, regs, size);
   alloca (0);
   return result;
 }
 #endif /* not emacs */
 
+#ifdef emacs
+/* In Emacs, this is the string or buffer in which we
+   are matching.  It is used for looking up syntax properties.	*/
+Lisp_Object re_match_object;
+#endif
 
 /* re_match_2 matches the compiled pattern in BUFP against the
-   (virtual) concatenation of STRING1 and STRING2 (of length SIZE1 and
-   SIZE2, respectively).  We start matching at POS, and stop matching
-   at STOP.
+   the (virtual) concatenation of STRING1 and STRING2 (of length SIZE1
+   and SIZE2, respectively).  We start matching at POS, and stop
+   matching at STOP.
 
    If REGS is non-null and the `no_sub' field of BUFP is nonzero, we
-   store offsets for the substring each group matched in REGS.  See the
+   store offsets for the substring each group matched in REGS.	See the
    documentation for exactly how many groups we fill.
 
    We return -1 if no match, -2 if an internal error (such as the
-   failure stack overflowing).  Otherwise, we return the length of the
+   failure stack overflowing).	Otherwise, we return the length of the
    matched substring.  */
 
 int
-re_match_2 (struct re_pattern_buffer *bufp, const char *string1,
-	    int size1, const char *string2, int size2, int pos,
-	    struct re_registers *regs, int stop)
-{
-  int result = re_match_2_internal (bufp, (re_char *) string1, size1,
-				    (re_char *) string2, size2,
-				    pos, regs, stop);
+re_match_2 (bufp, string1, size1, string2, size2, pos, regs, stop)
+     struct re_pattern_buffer *bufp;
+     const char *string1, *string2;
+     int size1, size2;
+     int pos;
+     struct re_registers *regs;
+     int stop;
+{
+  int result;
+
+#ifdef emacs
+  int charpos;
+  int adjpos = NILP (re_match_object) || BUFFERP (re_match_object);
+  gl_state.object = re_match_object;
+  charpos = SYNTAX_TABLE_BYTE_TO_CHAR (pos + adjpos);
+  SETUP_SYNTAX_TABLE_FOR_OBJECT (re_match_object, charpos, 1);
+#endif
+
+  result = re_match_2_internal (bufp, string1, size1, string2, size2,
+				pos, regs, stop);
   alloca (0);
   return result;
 }
 
 /* This is a separate function so that we can force an alloca cleanup
-   afterwards.  */
+   afterwards.	*/
 static int
-re_match_2_internal (struct re_pattern_buffer *bufp, re_char *string1,
-		     int size1, re_char *string2, int size2, int pos,
-		     struct re_registers *regs, int stop)
+re_match_2_internal (bufp, string1, size1, string2, size2, pos, regs, stop)
+     struct re_pattern_buffer *bufp;
+     const char *string1, *string2;
+     int size1, size2;
+     int pos;
+     struct re_registers *regs;
+     int stop;
 {
   /* General temporaries.  */
   int mcnt;
   unsigned char *p1;
-  int should_succeed; /* XEmacs change */
 
   /* Just past the end of the corresponding string.  */
-  re_char *end1, *end2;
+  const char *end1, *end2;
 
   /* Pointers into string1 and string2, just past the last characters in
-     each to consider matching.  */
-  re_char *end_match_1, *end_match_2;
+     each to consider matching.	 */
+  const char *end_match_1, *end_match_2;
 
   /* Where we are in the data, and the end of the current string.  */
-  re_char *d, *dend;
+  const char *d, *dend;
 
   /* Where we are in the pattern, and the end of the pattern.  */
   unsigned char *p = bufp->buffer;
-  REGISTER unsigned char *pend = p + bufp->used;
+  register unsigned char *pend = p + bufp->used;
 
   /* Mark the opcode just after a start_memory, so we can test for an
      empty subpattern when we get to the stop_memory.  */
-  re_char *just_past_start_mem = 0;
+  unsigned char *just_past_start_mem = 0;
 
-  /* We use this to map every character in the string.  */
+  /* We use this to map every character in the string.	*/
   RE_TRANSLATE_TYPE translate = bufp->translate;
 
+  /* Nonzero if we have to concern multibyte character.	 */
+  int multibyte = bufp->multibyte;
+
   /* Failure point stack.  Each place that can handle a failure further
      down the line pushes a failure point on this stack.  It consists of
      restart, regend, and reg_info for all registers corresponding to
@@ -4299,23 +4369,21 @@
      to resume scanning the pattern; the second one is where to resume
      scanning the strings.  If the latter is zero, the failure point is
      a ``dummy''; if a failure happens and the failure point is a dummy,
-     it gets discarded and the next one is tried.  */
-#ifdef MATCH_MAY_ALLOCATE /* otherwise, this is global.  */
+     it gets discarded and the next next one is tried.	*/
+#ifdef MATCH_MAY_ALLOCATE /* otherwise, this is global.	 */
   fail_stack_type fail_stack;
 #endif
 #ifdef DEBUG
-  static unsigned failure_id;
+  static unsigned failure_id = 0;
   unsigned nfailure_points_pushed = 0, nfailure_points_popped = 0;
 #endif
 
-#ifdef REL_ALLOC
   /* This holds the pointer to the failure stack, when
      it is allocated relocatably.  */
   fail_stack_elt_t *failure_stack_ptr;
-#endif
 
   /* We fill all the registers internally, independent of what we
-     return, for use in backreferences.  The number here includes
+     return, for use in backreferences.	 The number here includes
      an element for register zero.  */
   unsigned num_regs = bufp->re_nsub + 1;
 
@@ -4331,7 +4399,7 @@
      stopped matching the regnum-th subexpression.  (The zeroth register
      keeps track of what the whole pattern matches.)  */
 #ifdef MATCH_MAY_ALLOCATE /* otherwise, these are global.  */
-  re_char **regstart, **regend;
+  const char **regstart, **regend;
 #endif
 
   /* If a group that's operated upon by a repetition operator fails to
@@ -4340,7 +4408,7 @@
      are when we last see its open-group operator.  Similarly for a
      register's end.  */
 #ifdef MATCH_MAY_ALLOCATE /* otherwise, these are global.  */
-  re_char **old_regstart, **old_regend;
+  const char **old_regstart, **old_regend;
 #endif
 
   /* The is_active field of reg_info helps us keep track of which (possibly
@@ -4348,8 +4416,8 @@
      field of reg_info[reg_num] helps us tell whether or not we have
      matched any of the pattern so far this time through the reg_num-th
      subexpression.  These two fields get reset each time through any
-     loop their register is in.  */
-#ifdef MATCH_MAY_ALLOCATE /* otherwise, this is global.  */
+     loop their register is in.	 */
+#ifdef MATCH_MAY_ALLOCATE /* otherwise, this is global.	 */
   register_info_type *reg_info;
 #endif
 
@@ -4359,25 +4427,25 @@
      turn happens only if we have not yet matched the entire string. */
   unsigned best_regs_set = false;
 #ifdef MATCH_MAY_ALLOCATE /* otherwise, these are global.  */
-  re_char **best_regstart, **best_regend;
+  const char **best_regstart, **best_regend;
 #endif
 
   /* Logically, this is `best_regend[0]'.  But we don't want to have to
      allocate space for that if we're not allocating space for anything
-     else (see below).  Also, we never need info about register 0 for
+     else (see below).	Also, we never need info about register 0 for
      any of the other register vectors, and it seems rather a kludge to
      treat `best_regend' differently than the rest.  So we keep track of
      the end of the best match so far in a separate variable.  We
      initialize this to NULL so that when we backtrack the first time
      and need to test it, it's not garbage.  */
-  re_char *match_end = NULL;
+  const char *match_end = NULL;
 
   /* This helps SET_REGS_MATCHED avoid doing redundant work.  */
   int set_regs_matched_done = 0;
 
   /* Used when we pop values we don't care about.  */
 #ifdef MATCH_MAY_ALLOCATE /* otherwise, these are global.  */
-  re_char **reg_dummy;
+  const char **reg_dummy;
   register_info_type *reg_info_dummy;
 #endif
 
@@ -4386,13 +4454,6 @@
   unsigned num_regs_pushed = 0;
 #endif
 
-  /* 1 if this match ends in the same string (string1 or string2)
-     as the best previous match.  */
-  boolean same_str_p;
-
-  /* 1 if this match is the best seen so far.  */
-  boolean best_match_p;
-
   DEBUG_PRINT1 ("\n\nEntering re_match_2.\n");
 
   INIT_FAIL_STACK ();
@@ -4405,29 +4466,29 @@
      array indexing.  We should fix this.  */
   if (bufp->re_nsub)
     {
-      regstart       = REGEX_TALLOC (num_regs, re_char *);
-      regend         = REGEX_TALLOC (num_regs, re_char *);
-      old_regstart   = REGEX_TALLOC (num_regs, re_char *);
-      old_regend     = REGEX_TALLOC (num_regs, re_char *);
-      best_regstart  = REGEX_TALLOC (num_regs, re_char *);
-      best_regend    = REGEX_TALLOC (num_regs, re_char *);
-      reg_info       = REGEX_TALLOC (num_regs, register_info_type);
-      reg_dummy      = REGEX_TALLOC (num_regs, re_char *);
+      regstart = REGEX_TALLOC (num_regs, const char *);
+      regend = REGEX_TALLOC (num_regs, const char *);
+      old_regstart = REGEX_TALLOC (num_regs, const char *);
+      old_regend = REGEX_TALLOC (num_regs, const char *);
+      best_regstart = REGEX_TALLOC (num_regs, const char *);
+      best_regend = REGEX_TALLOC (num_regs, const char *);
+      reg_info = REGEX_TALLOC (num_regs, register_info_type);
+      reg_dummy = REGEX_TALLOC (num_regs, const char *);
       reg_info_dummy = REGEX_TALLOC (num_regs, register_info_type);
 
       if (!(regstart && regend && old_regstart && old_regend && reg_info
-            && best_regstart && best_regend && reg_dummy && reg_info_dummy))
-        {
-          FREE_VARIABLES ();
-          return -2;
-        }
+	    && best_regstart && best_regend && reg_dummy && reg_info_dummy))
+	{
+	  FREE_VARIABLES ();
+	  return -2;
+	}
     }
   else
     {
       /* We must initialize all our variables to NULL, so that
-         `FREE_VARIABLES' doesn't try to free them.  */
+	 `FREE_VARIABLES' doesn't try to free them.  */
       regstart = regend = old_regstart = old_regend = best_regstart
-        = best_regend = reg_dummy = NULL;
+	= best_regend = reg_dummy = NULL;
       reg_info = reg_info_dummy = (register_info_type *) NULL;
     }
 #endif /* MATCH_MAY_ALLOCATE */
@@ -4445,15 +4506,16 @@
   for (mcnt = 1; mcnt < num_regs; mcnt++)
     {
       regstart[mcnt] = regend[mcnt]
-        = old_regstart[mcnt] = old_regend[mcnt] = REG_UNSET_VALUE;
+	= old_regstart[mcnt] = old_regend[mcnt] = REG_UNSET_VALUE;
 
       REG_MATCH_NULL_STRING_P (reg_info[mcnt]) = MATCH_NULL_UNSET_VALUE;
       IS_ACTIVE (reg_info[mcnt]) = 0;
       MATCHED_SOMETHING (reg_info[mcnt]) = 0;
       EVER_MATCHED_SOMETHING (reg_info[mcnt]) = 0;
     }
+
   /* We move `string1' into `string2' if the latter's empty -- but not if
-     `string1' is null.  */
+     `string1' is null.	 */
   if (size2 == 0 && string1 != NULL)
     {
       string2 = string1;
